#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <io.h>
#include <dos.h>
#include <int.h>
#include <time.h>
#include <ctype.h>
#include <disp.h>
#include "cornet.h"


/*---- code ---------------------------------------------------*/


/*===============================================*
*  Delay function                                *
*===============================================*/
void delay (ulong tx)
// tx - uSec,  typically min resolution >= 1000 uS
{
   union REGS r;

   r.x.ax = 0x8600;
   r.x.cx = HiWord(tx);
   r.x.dx = LoWord(tx);

   int86 (0x15, &r, &r);
}


/*===============================================*
*  Init timeout interval                         *
*===============================================*/
void tout_init (ulong tx, uchar far *f)
// tx - uSec,  typically min resolution >= 1000 uS
// *f - address of flag byte
{
   union REGS r;
   struct SREGS sr;

   r.x.ax = 0x8300;
   r.x.cx = HiWord(tx);
   r.x.dx = LoWord(tx);
   r.x.bx = FP_OFF(f);
   sr.es  = FP_SEG(f);
   *f = 0;

   int86x (0x15, &r, &r, &sr);
}


/*===============================================*
*  Cancel timeout interval                       *
*===============================================*/
void tout_cancel (void)
{
   union REGS r;

   r.x.ax = 0x8301;
   int86 (0x15, &r, &r);
}


/********************************/
/* ୥   int, uint */
/********************************/
void reverse_word (void *p, int n)
{
   uchar tmp;
   int i;

   for (i=0; i<n; i++) {
      tmp = ((uchar *)p)[0];
      ((uchar *)p)[0] = ((uchar *)p)[1];
      ((uchar *)p)[1] = tmp;
      ((uchar *)p) += 2;
      }
}


/*****************************************/
/* ୥   long, ulong, float */
/*****************************************/
void reverse_dword (void *p, int n)
{
   uchar tmp;
   int i;

   for (i=0; i<n; i++) {
      tmp = ((uchar *)p)[0];
      ((uchar *)p)[0] = ((uchar *)p)[3];
      ((uchar *)p)[3] = tmp;

      tmp = ((uchar *)p)[1];
      ((uchar *)p)[1] = ((uchar *)p)[2];
      ((uchar *)p)[2] = tmp;

      ((uchar *)p) += 4;
      }
}


/********************************/
/* ୥    */
/********************************/
void reverse_struct (void *p, uint *s)
// p - ⮪ 
// s -   ࠬ :
//     ᯨ᮪   ᥫ:  (୨ ) -  ,
//     㣥 (୨ ) - ஧   ;
//      ᯨ -  쮢 祭 ᫠ ;
{
   uint n, sz;

   for ( ; *s; s+=2) {
      n = *s;
      sz = *(s+1);
      switch (sz) {
         case 1 : ((uchar *)p) += n;
                  break;
         case 2 : reverse_word (p, n);
                  ((uint *)p) += n;
                  break;
         case 4 : reverse_dword (p, n);
                  ((ulong *)p) += n;
                  break;
         default: ((uchar *)p) += (n * sz);
         }
      }
}


/********************************************/
/* ⢮७ ulongfloat ᫠    */
/********************************************/
void ulf2str (char *buf, ulongfloat *p, int ni, int nf)
// ni -     ⨭
// nf -    ஡ ⨭
{
   static char bfrc[16];

   sprintf (bfrc, "%.*f", nf, p->fr);

      //  㢠,   ஡ ⨭ ᫠  < 1, 
      //  sprintf- ᫮ 㣫     == 1;
      //  ⠪    ulong ⨭ ᫠  1;
   sprintf (buf, "%*lu%s", ni,}   p->it + (*bfrc - '0'), bfrc+1);
      // xxxxxxxxxx.xxx



